#!/bin/bash
# Count empty and non empty user agents from valid HTTP requests
DATABASE=$1

if [ -z "$DATABASE" ]; then
    echo "No database was specified" >&2
    exit 1
fi

if [ ! -e "$DATABASE" ]; then
    echo "Database not found" >&2
    exit 1
fi

QUERY="SELECT COUNT(*) FROM httpreq WHERE (NOT meth = \"\") AND NOT ua=\"\";"
SETUASTR=$(echo $QUERY | sqlite3 $DATABASE || exit 1)

QUERY="SELECT COUNT(*) FROM httpreq WHERE (NOT meth =\"\") AND ua=\"\";"
EMPTYUASTR=$(echo $QUERY | sqlite3 $DATABASE || exit 1)

echo "$SETUASTR $EMPTYUASTR"
