#!/usr/bin/perl
# Merge multiple tmp_uats tables in one table
use strict;
use DBI;
use UserAgents;


my $mdb = "/data/tor/torgame/data/merged-uats.db";
my $root="/data/tor/databases";

my $dbargs = {AutoCommit => 1, PrintError => 1};
my $dbh_dst = DBI->connect("dbi:SQLite:dbname=$mdb","","",$dbargs) or 
        die "Cannot connect  to database $mdb\n";


sub mergedb{
    my $filename = shift;
    print "filename: $filename\n";
    my $dbh_src = DBI->connect("dbi:SQLite:dbname=$filename","","",$dbargs) or 
        die "Cannot connect  to database $filename\n";
    my $query = "SELECT ts,ua,vul FROM tmp_uats;";
    my $sth =$dbh_src->prepare($query) or die $dbh_src->errstr."\n";
    $sth->execute() or die $dbh_src->errstr."\n";
    my ($ts,$ua,$vul);
    $sth->bind_columns(\$ts,\$ua,\$vul);
    while ($sth->fetch()){
        # Insert values in the merged database
        my $qry="INSERT INTO tmp_uats (ts,ua,vul) VALUES (?,?,?);";
        my $s = $dbh_dst->prepare($qry) or die "error\n";
        $s->execute($ts,$ua,$vul) or die "error\n";
    }  

    $dbh_src->disconnect;
}
# Create final database
my $query="create table tmp_uats(id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, 
ua VARCHAR(200), ts DATETIME NOT NULL, vul INETEGER);";

$dbh_dst->do($query) or die $dbh_dst->errstr."\n";

# Go through files
opendir H, "$root" or die $?."\n";
my @files  = readdir(H);
my $i=0;
foreach my $file (@files){
    if ($file=~/\.db$/){
        my $f = "$root/$file";
        print "<$i> Processing file: $f\n";
        &mergedb($f);
        $i++;
    }
}
$dbh_dst->commit;
$dbh_dst->disconnect;
exit 0;
