#!/usr/bin/perl
use strict;
my $hist={};
sub inspect_file{
    my $filename = shift;
    open F,"<$filename"  or die "Cannot open $filename";
    while (<F>){
        my $line = $_;
        if ($line=~/Content-Type: (.+)/){
            # Remove extensions
            $line=~s/;.+$//g;
            #Remove spaces
            $line=~s/\s//g;
            $hist->{$line}++;
        }
    }
    close F;
}
# Take a list of filenames as input  and extract the Mime-Type 
while (<>){
    chomp;
    &inspect_file($_);
}

# Compute relative frequencies
my $sum = 0;
foreach my $mt (keys(%{$hist})){
    $sum+=$hist->{$mt};
}

foreach my $mt (keys(%{$hist})){
    $hist->{$mt}/=$sum;
}

# Dump it
foreach my $mt (sort {$hist->{$b} <=> $hist->{$a}} keys(%{$hist})){
    my $freq = $hist->{$mt};
    print "$mt $freq\n";
}
