#!/usr/bin/perl
use FuzzyCVE;
use Data::Dumper;
use Test::Simple tests=>10;
use Test::Deep;
my $fc = FuzzyCVE->new('BIND');
my $VAR1;
$fc->load('data/cve0.txt'); 

$VAR1 = {
          'BIND' => {
                      '4.9' => [
                                 'CVE-1999-0009'
                               ]
                    }
        };
cmp_deeply($fc->{keywordCache},$VAR1);

#### test 2

$fc = FuzzyCVE->new;
$fc->load('data/cve0.txt');
$VAR1={};
cmp_deeply($fc->{keywordCache},$VAR1);

#### Test 2
$fc->load('data/cve0.txt');
cmp_deeply($fc->{keywordCache},$VAR1);

#### Test 3
$fc = FuzzyCVE->new('LinkBase','Battle Blog', 'Microchip MPLAB IDE');
$fc->load('data/cve1.txt');
$VAR1 = {
          'Battle Blog' => {
                             '1.25' => [
                                         'CVE-2009-1609'
                                       ]
                           },
          'Microchip MPLAB IDE' => {
                                     '8.30' => [
                                                 'CVE-2009-1608'
                                               ]
                                   },
          'LinkBase' => {
                          '2.0' => [
                                     'CVE-2009-1607'
                                   ]
                        }
        };

cmp_deeply($VAR1,$fc->{keywordCache});

### Test 4
$VAR1 = {
          'foo' => {
                    '1.0' => [
                                         'CVE-2009-1609',
                                         'CVE-2009-8766'
                                       ]
                           },
          'bar' => {
                                     '0.5' => [
                                                 'CVE-2009-1608'
                                               ],
                                     '0.9' => [
                                                'CVE-2009-1223',
                                                'CVE-2009-9871'
                                              ]
                                   }
        };


# Test counting
$fc->{keywordCache} = $VAR1;
my $x = $fc->get_product_cve_num('foo');
ok($x==2);
# Test 5
my $x = $fc->get_product_cve_num('bar');
ok($x==3);

# Test 6 - look for a special vulnerability
$x = $fc->get_product_cve_num('bar',0.5);
ok($x==1);
# Test 7
$x = $fc->get_product_cve_num('bar',0.9);
ok($x==2);

# Test 8 // non existing product
$x = $fc->get_product_cve_num('brol');
ok($x ==0);
# Test 9 // non existing version 
$x = $fc->get_product_cve_num('foo','2.0');
ok($x ==0);
